import java.awt.*;

public class InputFrame extends Frame {

  String sql, id1, id2;
  SQLclient sqlclient;
  TextArea in, out;
  TextField  name, age, age1, age2, email;
  Button button, button1, button2, button3;
  CheckboxGroup sexgroup, groupgroup;
  Checkbox[] sex;
  Choice choice, choice1;
  Checkbox check1, check2, check3, check4, check5, check6, check7;
  boolean visible;
  Choice [] choiceOrd, order;
  Color c = new Color (64, 128, 128);
  Menu d;
  MenuBar mb;

 public InputFrame (String Title, SQLclient sqlclient) {

  super (Title);
  this.sqlclient = sqlclient;
  visible = true;
  setBackground (c);
  out = new TextArea (3,65);
  in = new TextArea (1, 65);
  name = new TextField (25);
  age = new TextField (2);
  email = new TextField (24);
  button1 = new Button ("Add to database");
  button2 = new Button ("Clear");
  sexgroup = new CheckboxGroup();
  sex = new Checkbox[2];
  sex[0] = new Checkbox ("Male", sexgroup, true);
  sex[1] = new Checkbox ("Female", sexgroup, false);
  
  GridBagLayout gridbag = new GridBagLayout ();

  setLayout (gridbag);
  constrain (this, new Label ("Student's name:"), 0, 0, 2, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,0,0);
  constrain (this, name, 0, 1, 2, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,5,0);
  constrain (this, new Label ("Sex:"), 0, 2, 1, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,0,0);
  constrain (this, sex[0], 0, 3, 2, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,0,0);
  constrain (this, sex[1], 0, 4, 2, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,0,0);
  constrain (this, new Label ("Age:"), 0, 5, 1, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,5,0,0,0);
  constrain (this, age, 0, 6, 1, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,5,0);
  constrain (this, new Label ("E-mail:"), 1, 5, 1, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,5,0,0,0);
  constrain (this, email, 1, 6, 3, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,5,0);
  constrain (this, button1, 0, 7, 2, 1,
  GridBagConstraints.BOTH, GridBagConstraints.WEST,0,0,5,5);
  constrain (this, button2, 2, 7, 1, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,5,0);
  constrain (this, new Label ("SQL sentence sent to a database:"),
  0, 8, 4, 1, GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,0,0);
  constrain (this, in, 0, 9, 4, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,5,0);
  constrain (this, new Label ("Report:"),
  0, 10, 1, 1, GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,0,0);
  constrain (this, out, 0, 11, 4, 4,
  GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,5,0);

  in.setEditable (false);
  out.setEditable(false);
  name.requestFocus ();
  MenuBar mb = new MenuBar ();
  Menu d = new Menu ("File");
  d.add (new MenuItem ("Exit"));
  mb.add(d);
  setMenuBar (mb);

 }

 public InputFrame (String Title, SQLclient sqlclient, int k) {

  super (Title);
  visible = true;
  choice = new Choice ();
  choice1 = new Choice ();

  this.sqlclient = sqlclient;
  out = new TextArea (3,65);
  in = new TextArea (1, 65);

  choice = sqlclient.makeChoice ("SELECT ID, Name FROM Students;");
  choice1 = sqlclient.makeChoice ("SELECT ID, Title FROM Courses;");

  button = new Button ("Apply to a course");

  setBackground (c);

  GridBagLayout gridbag = new GridBagLayout ();

  setLayout (gridbag);
  constrain (this, new Label ("Select Student's ID and name:"), 0, 0, 2, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,0,0);
  constrain (this, choice, 0, 1, 2, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,5,0);
  constrain (this, new Label ("Select Course ID and Title:"), 2, 0, 2, 1,
  GridBagConstraints.NONE, GridBagConstraints.EAST,0,0,0,0);
  constrain (this, choice1, 2, 1, 2, 1,
  GridBagConstraints.NONE, GridBagConstraints.EAST,0,0,5,0);
  constrain (this, button, 0, 2, 4, 1,
  GridBagConstraints.NONE, GridBagConstraints.CENTER,0,0,5,0);
  constrain (this, new Label ("SQL sentence sent to a database:"),
  0, 3, 4, 1, GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,0,0);
  constrain (this, in, 0, 4, 4, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,5,0);
  constrain (this, new Label ("Report:"),
  0, 5, 1, 1, GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,0,0);
  constrain (this, out, 0, 6, 4, 4,
  GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,5,0);

  in.setEditable (false);
  out.setEditable(false);
  MenuBar mb = new MenuBar ();
  Menu d = new Menu ("File");
  d.add (new MenuItem ("Exit"));
  mb.add(d);
  setMenuBar (mb);

 }

 public InputFrame (String Title, SQLclient sqlclient, boolean ind) {

  super (Title);
   
  this.sqlclient = sqlclient;
  visible = true;
  out = new TextArea (3, 85);
  in = new TextArea (1, 85);
  name = new TextField (20);
  age1 = new TextField (2);
  age2 = new TextField (2);
  email = new TextField (24);
  button1 = new Button ("Make Querry");
  button2 = new Button ("Execute Querry");
  button3 = new Button ("Restore");
  choiceOrd = new Choice [7];
  order = new Choice [7];

  for (int i = 0; i < 7; i ++) {
   choiceOrd[i] = makeCh ();
   order [i] = makeCh1 ();
  }

  sexgroup = new CheckboxGroup();
  sex = new Checkbox[3];
  sex[0] = new Checkbox ("Male", sexgroup, false);
  sex[1] = new Checkbox ("Female", sexgroup, false);
  sex[2] = new Checkbox ("All", sexgroup, true);

  check1 = new Checkbox ("ID", null, true);
  check2 = new Checkbox ("Name", null, true);
  check3 = new Checkbox ("Sex", null, true);
  check4 = new Checkbox ("Age", null, true);
  check5 = new Checkbox ("E-mail", null, true);
  check6 = new Checkbox ("ID", null, true);
  check7 = new Checkbox ("Title", null, true);

  setBackground (c);

  GridBagLayout gridbag = new GridBagLayout ();

  setLayout (gridbag);
  constrain (this, new Label ("SELECT COLUMNS TO INCLUDE IN REPORT"), 0, 0, 6, 1,
  GridBagConstraints.WEST, GridBagConstraints.WEST,0,0,0,0);
  constrain (this, new Label ("Table Students"), 0, 1, 5, 1,
  GridBagConstraints.CENTER, GridBagConstraints.CENTER,0,0,0,0);
  constrain (this, new Label ("Table Courses"), 6, 1, 2, 1,
  GridBagConstraints.CENTER, GridBagConstraints.WEST,0,0,0,0); 
  constrain (this, check1, 0, 2, 1, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,0,0); 
  constrain (this, check2, 1, 2, 1, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,0,0);
  constrain (this, check3, 2, 2, 1, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,0,0);
  constrain (this, check4, 3, 2, 1, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,0,0);
  constrain (this, check5, 4, 2, 1, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,0,0);
  constrain (this, check6, 6, 2, 1, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,0,0);
  constrain (this, check7, 7, 2, 1, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,0,0);
  constrain (this, new Label ("WHERE:"), 0, 3, 2, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,0,0);
  constrain (this, new Label ("Name like:"), 0, 4, 2, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,0,0);
  constrain (this, name, 2, 4, 3, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,5,0);
  constrain (this, new Label ("Sex:"), 5, 4, 1, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,0,0);
  constrain (this, sex[0], 6, 4, 1, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,0,0);
  constrain (this, sex[1], 7, 4, 1, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,0,0);
  constrain (this, sex[2], 8, 4, 1, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,0,0);
  constrain (this, new Label ("Age"), 0, 6, 1, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,5,0,0,0);
  constrain (this, new Label ("from:"), 1, 6, 1, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,5,0,0,0);
  constrain (this, age1, 2, 6, 1, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,5,0);
  constrain (this, new Label ("to:"), 3, 6, 1, 1,
  GridBagConstraints.NONE, GridBagConstraints.CENTER,5,0,0,0);
  constrain (this, age2, 4, 6, 1, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,5,0);
  constrain (this, new Label ("E-mail like:"), 5, 6, 1, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,5,0,0,0);
  constrain (this, email, 6, 6, 3, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,5,0);
  constrain (this, new Label ("ORDER BY:"), 0, 9, 2, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,5,0);
  constrain (this, choiceOrd[0], 0, 10, 2, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,5,0);
  constrain (this, order[0], 2, 10, 1, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,5,0);
  constrain (this, choiceOrd[1], 3, 10, 2, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,5,0);
  constrain (this, order[1], 5, 10, 1, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,5,0);
  constrain (this, choiceOrd[2], 6, 10, 2, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,5,0);
  constrain (this, order[2], 8, 10, 1, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,5,0);
  constrain (this, choiceOrd[3], 0, 11, 2, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,5,0);
  constrain (this, order[3], 2, 11, 1, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,5,0);
  constrain (this, choiceOrd[4], 3, 11, 2, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,5,0);
  constrain (this, order[4], 5, 11, 1, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,5,0);
  constrain (this, choiceOrd[5], 6, 11, 2, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,5,0);
  constrain (this, order[5], 8, 11, 1, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,5,0);
  constrain (this, choiceOrd[6], 0, 12, 2, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,5,0);
  constrain (this, order[6], 2, 12, 1, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,5,0);
  constrain (this, button1, 0, 13, 3, 1,
  GridBagConstraints.BOTH, GridBagConstraints.WEST,0,0,5,5);
  constrain (this, button2, 3, 13, 2, 1,
  GridBagConstraints.EAST, GridBagConstraints.WEST,0,0,5,0);
  constrain (this, button3, 5, 13, 3, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,5,0);
  constrain (this, new Label ("SQL sentence sent to a database:"),
  0, 14, 6, 1, GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,0,0);
  constrain (this, in, 0, 15, 12, 1,
  GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,5,0);
  constrain (this, new Label ("Report:"),
  0, 16, 2, 1, GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,0,0);
  constrain (this, out, 0, 17, 12, 3,
  GridBagConstraints.NONE, GridBagConstraints.WEST,0,0,5,0);

  out.setEditable(false);
  name.requestFocus ();
  MenuBar mb = new MenuBar ();
  Menu d = new Menu ("File");
  d.add (new MenuItem ("Exit"));
  mb.add(d);
  setMenuBar (mb);

 }

 public boolean action (Event evt, Object arg) {

  if(evt.target instanceof MenuItem) {
   String label = (String)arg;
   if (label.equals ("Exit")){
    sqlclient.inputs = false;
    sqlclient.inputc = false;
    sqlclient.inputq = false;
    hide ();
    dispose ();
    return true;
   }
  }

  if (evt.target instanceof Button) {

   if ((String) arg == "Add to database") {

    in.setText ("");
    out.setText ("");

    if (name.getText ().length () == 0) {
     out.appendText ("You must fill Your name");
     name.requestFocus ();
     return false;
    }

    if (age.getText ().length () == 0) {
     out.appendText ("You must fill Your age");
     age.requestFocus ();
     return false;
    }

    if (email.getText ().length () == 0) {
     out.appendText ("You must fill Your email adress");
     email.requestFocus ();
     return false;
    }

    sql = " ";

    sql = "SELECT COUNT (*) FROM Students WHERE Name = '" + name.getText () +
    "' AND Email = '" + email.getText () + "';";

    sqlclient.send (sql);
    
    if (out.getText ().startsWith ("1")) {
     out.setText ("");
     out.appendText
     ("Student with specified name and E-mail adress already exists.");
     return false;
    }

    out.setText ("");

    sql = " ";

    String sex1 = sexgroup.getCurrent ().getLabel ();

    sql = "INSERT INTO Students (Name, Sex, Age, Email) VALUES ('" +
    name.getText () + "','" + sex1 + "'," +
    Integer.parseInt (age.getText ()) + ",'" + email.getText () + "');";

    in.setText ("");
   
    in.appendText (sql);

    sqlclient.send (sql);

   }

   if ((String) arg == "Clear") {

    out.setText ("");
    in.setText ("");
    name.setText ("");
    email.setText ("");
    age.setText ("");
    sexgroup.setCurrent (sex[0]);
    name.requestFocus ();
    
   }

   if ((String) arg == "Restore") {

    out.setText ("");
    in.setText ("");
    name.setText ("");
    email.setText ("");
    age1.setText ("");
    age2.setText ("");
    sexgroup.setCurrent (sex[2]);
    check1.setState (true);
    check2.setState (true);
    check3.setState (true);
    check4.setState (true);
    check5.setState (true);
    check6.setState (true);
    check7.setState (true);
    for (int i = 0; i < 7; i ++) {
     choiceOrd [i].select ("None");
     order [i].select ("Asc");
    }
    
   }


   if ((String) arg == "Apply to a course") {

    in.setText ("");
    out.setText ("");

    int id = choice.getSelectedItem ().indexOf (",") - 3;
    int id1 = choice1.getSelectedItem ().indexOf (",") - 3;

    String str = choice.getSelectedItem ().substring (0, id);
    String str1 = choice1.getSelectedItem ().substring (0, id1);

    sql = " ";

    sql = "SELECT COUNT (*) FROM StudentsCourses WHERE StudentID = " +
    Integer.parseInt (str) + " AND CourseID = " + Integer.parseInt (str1) +
    ";";

    sqlclient.send (sql);

    if (Integer.parseInt(out.getText ().substring (0,1)) > 0) {
     out.setText ("");
     out.appendText
     ("Selected student has already applied for selected course.");
     return false;
    } 

    out.setText ("");

    sql = " ";

    sql = "INSERT INTO StudentsCourses (StudentID, CourseID) VALUES (" +
    Integer.parseInt (str) + "," +
    Integer.parseInt (str1) + ");";

    in.setText ("");
   
    in.appendText (sql);

    sqlclient.send (sql);

   }

   if ((String) arg == "Execute Querry") {

    out.setText ("");

    sql = in.getText ();

    if (in.getText ().length () != 0)
     sqlclient.send (sql);

   }

   if ((String) arg == "Make Querry") {

    out.setText ("");

    in.setText (makeCon ());

   }

  return true;

  }

  return false;

 }

 public void constrain (Container container, Component component, int x,
 int y, int w, int h, int f, int anc, int t, int l, int b, int r) {

  GridBagConstraints c = new GridBagConstraints ();
  c.gridx = x;
  c.gridy = y;
  c.gridwidth = w;
  c.gridheight = h;
  c.fill = f;
  c.anchor = anc;
  c.insets = new Insets (t, l, b, r);
  ((GridBagLayout) container.getLayout ()).setConstraints (component, c);
  container.add (component);

 }

 public String makeCon () {

  String con1, con2, con3, con4, con5, con6, con7;
  String con8, con9, con10, con11, con12, con13, con14;
  String querry;
  boolean ctr, ctr1, ctr2, ctr3;

  ctr = ctr1 = ctr2 = false;

  if (check1.getState ()) {
   con1 = " Students.ID";
   ctr1 = true;
  }
  else
   con1 = "";

  if (check2.getState ()) {
   if (ctr1)
    con2 = ", Students.Name";
   else
    con2 = " Students.Name";
   ctr1 = true;
  }
  else
   con2 = "";

  if (check3.getState ()) {
   if (ctr1)
    con3 = ", Students.Sex";
   else
    con3 = " Students.Sex";
   ctr1 = true;
  }
  else
   con3 = "";

  if (check4.getState ()) {
   if (ctr1)
    con4 = ", Students.Age";
   else
    con4 = " Students.Age";
    ctr1 = true;
  }
  else
   con4 = "";

  if (check5.getState ()) {
   if (ctr1)
    con5 = ", Students.Email";
   else
    con5 = " Students.Email";
    ctr1 = true;
  }
  else
   con5 = "";

  if (check6.getState ()) {
   if (ctr1)
    con6 = ", Courses.ID";
   else
    con6 = " Courses.ID";
    ctr = true;
  }
  else
   con6 = "";

  if (check7.getState ()) {
   if (ctr1 || ctr) 
    con7 = ", Courses.Title";
   else
    con7 = " Courses.Title";
    ctr = true;
  }
  else
   con7 = "";

  con8 = "";

  if (name.getText ().length () > 0) {
   con9 = " WHERE Students.Name LIKE '%" + name.getText () + "%'";
   ctr2 = true;
  }
  else
   con9 = "";
  if (sex [0].getState ()) {
   if (ctr2)
    con10 = " AND Students.Sex = 'Male'";
   else
    con10 = " WHERE Students.Sex = 'Male'";
   ctr2 = true;
  }
  else
  if (sex [1].getState ()) {
   if (ctr2)
    con10 = " AND Students.Sex = 'Female'";
   else
    con10 = " WHERE Students.Sex = 'Female'";
    ctr2 = true;
  }
  else
   con10 = "";

  if (age1.getText ().length () > 0) {
   if (ctr2) 
    con11 = " AND Students.Age >= " + Integer.parseInt (age1.getText ());
   else
    con11 = " WHERE Students.Age >= " + Integer.parseInt (age1.getText ()); 
   ctr2 = true;
  }

  else
   con11 = "";

  if (age2.getText ().length () > 0) {
   if (ctr2) 
    con12 = " AND Students.Age <= " + Integer.parseInt (age2.getText ());
   else
    con12 = " WHERE Students.Age <= " + Integer.parseInt (age2.getText ()); 
   ctr2 = true;
  }
  else
   con12 = "";

  if (email.getText ().length () > 0) {
   if (ctr2) 
    con13 = " AND Students.Email LIKE '%" + email.getText () + "%'";
   else
    con13 = " WHERE Students.Email LIKE '%" + email.getText () + "%'"; 
   ctr2 = true;
  }
  else
   con13 = "";

  ctr3 = false;
  for (int i = 0; i < 5; i ++) 
   if (choiceOrd [i].getSelectedItem () != "None")
    ctr3 = true;

  if ((ctr && ctr1) || (ctr && ctr2 && !ctr1) || (ctr && ctr3)) {
   if (ctr2) 
    con14 = " AND Students.ID = StudentsCourses.StudentID AND Courses.ID =" +
    " StudentsCourses.CourseID";
   else
    con14 = " WHERE Students.ID = StudentsCourses.StudentID AND Courses.ID =" +
    " StudentsCourses.CourseID";  
  }
  else
   con14 = "";

  if ((ctr && ctr1) || (ctr && ctr2 && !ctr1) || (ctr && ctr3))
   con8 = " FROM Students, Courses, StudentsCourses";
  else
  if (ctr && !ctr1)
   con8 = " FROM Courses";
  else
  if (!ctr && ctr1)
   con8 = " FROM Students";     

  querry = "SELECT" + con1 + con2 + con3 + con4 + con5 + con6 + con7 +
  con8 + con9 + con10 + con11 + con12 + con13 + con14;

  querry = querry + makeOrder ();

  if (!ctr && !ctr1)
   querry = "";

  return querry;

 }

 public Choice makeCh () {
  Choice ch = new Choice ();
  ch.addItem ("None");
  ch.addItem ("Students.ID");
  ch.addItem ("Students.Name");
  ch.addItem ("Students.Sex");
  ch.addItem ("Students.Age");
  ch.addItem ("Students.Email");
  ch.addItem ("Courses.ID");
  ch.addItem ("Courses.Title");
  return ch;
 }

 public Choice makeCh1 () {
  Choice ch1 = new Choice ();
  ch1.addItem ("Asc");
  ch1.addItem ("Desc");
  return ch1;
 }

 public String makeOrder () {

  boolean pass1 = false;
  String finalorder = "";
  String [] ord;
  ord = new String [7];

  for (int i = 0; i < 7; i ++)
   ord [i] = "";

  for (int i = 6; i > -1; i --) {
   boolean pass = true;
   if (choiceOrd[i].getSelectedItem () != "None") {
    for (int j = i - 1; j > -1; j --) {  
     if (choiceOrd [i].getSelectedItem () == choiceOrd [j].getSelectedItem ()) 
      pass = false;
    }
    if (pass) {
     ord [i] = ", " + choiceOrd [i].getSelectedItem () + " " +
     order [i].getSelectedItem ();
     pass1 = true;
    }
    else
     ord [i] = "";
   }

  }

  if (pass1) { 
   for (int i = 0; i < 7; i ++) 
    finalorder = finalorder + ord [i];
   finalorder = finalorder.substring (2);
   finalorder = " ORDER BY " + finalorder;
  }

  return finalorder;

 }
  
}
